'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _atRule = require('postcss/lib/at-rule');

var _atRule2 = _interopRequireDefault(_atRule);

var _comment = require('postcss/lib/comment');

var _comment2 = _interopRequireDefault(_comment);

var _parser = require('postcss/lib/parser');

var _parser2 = _interopRequireDefault(_parser);

var _lessTokenize = require('./less-tokenize');

var _lessTokenize2 = _interopRequireDefault(_lessTokenize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MixinDefinitionPattern = /^([#.](?:[\w-]|\\(?:[A-Fa-f0-9]{1,6} ?|[^A-Fa-f0-9]))+)\s*\(/;

var LessParser = function (_Parser) {
    _inherits(LessParser, _Parser);

    function LessParser(input, opts) {
        _classCallCheck(this, LessParser);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(LessParser).call(this, input));

        _this.mixins = {};
        _this.mixinsAsAtRules = (opts || {}).mixinsAsAtRules;
        return _this;
    }

    _createClass(LessParser, [{
        key: 'tokenize',
        value: function tokenize() {
            this.tokens = (0, _lessTokenize2.default)(this.input);
        }
    }, {
        key: 'comment',
        value: function comment(token) {
            if (token[6] === 'inline') {
                var node = new _comment2.default();

                this.init(node, token[2], token[3]);
                node.raws.inline = true;
                node.source.end = { line: token[4], column: token[5] };

                var text = token[1].slice(2);

                if (/^\s*$/.test(text)) {
                    node.text = '';
                    node.raws.left = text;
                    node.raws.right = '';
                } else {
                    var match = text.match(/^(\s*)([^]*[^\s])(\s*)$/);

                    node.text = match[2];
                    node.raws.left = match[1];
                    node.raws.right = match[3];
                }
            } else {
                _get(Object.getPrototypeOf(LessParser.prototype), 'comment', this).call(this, token);
            }
        }
    }, {
        key: 'rule',
        value: function rule(token) {
            var _this2 = this;

            _get(Object.getPrototypeOf(LessParser.prototype), 'rule', this).call(this, token);

            if (MixinDefinitionPattern.test(this.current.source.input.css)) {
                (function () {
                    // this.current is the 'rule' node created in super.rule()
                    _this2.current.name = token[0][1].slice(1);

                    if (_this2.mixinsAsAtRules === true) {
                        _this2.current.type = 'atrule';
                        _this2.current.lessType = 'mixin';
                    } else {
                        _this2.current.type = 'mixin';
                    }

                    _this2.current.definition = true;
                    _this2.current.params = [];

                    var blockStart = token.findIndex(function (x) {
                        return x[0] === '(';
                    });
                    var blockEnd = token.findIndex(function (x) {
                        return x[0] === ')';
                    });

                    token.forEach(function (tokn) {
                        if (tokn[0] !== 'mixin-param') {
                            return;
                        }

                        var index = token.indexOf(tokn);
                        var param = new _atRule2.default();
                        var pos = blockStart;
                        var prev = _this2.current.params[_this2.current.params.length - 1];
                        var termToken = null;

                        param.name = tokn[1].slice(1);
                        param.type = 'mixin-param';
                        param.source = {
                            start: { line: tokn[2], column: tokn[3] },
                            input: _this2.input
                        };
                        param.raws = { before: '', after: '', between: '' };

                        if (tokn[6] && tokn[6] === 'var-dict') {
                            param.variableDict = true;
                        }

                        while (pos < blockEnd) {
                            termToken = token[pos];

                            if (termToken[0] === ';') {
                                param.source.end = { line: termToken[2], column: termToken[3] };
                                param.raws.semicolon = true;
                                blockStart = pos + 1;
                                break;
                            } else if (termToken[0] === 'space') {
                                param.raws.before += termToken[1];

                                if (prev) {
                                    prev.raws.after += termToken[1];
                                }
                            }

                            pos += 1;
                        }

                        // this is the last param in the block
                        if (pos === blockEnd) {
                            pos = index;
                            while (pos < blockEnd) {
                                termToken = token[pos];

                                if (termToken[0] === 'space') {
                                    param.raws.after += termToken[1];
                                }

                                pos += 1;
                            }

                            param.source.end = { line: tokn[4], column: tokn[5] };
                        }

                        _this2.current.params.push(param);
                    });
                })();
            }
        }
    }]);

    return LessParser;
}(_parser2.default);

exports.default = LessParser;
module.exports = exports['default'];